/*****************************************************************
 *****************     BACKGROUND          *************************
 ******************************************************************
 FICHERO backg.c: Este modulo contiene los procedimientos que
 permiten tratar con el backgorund:
************************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>

#include "const.h"
#include "estruc.h"
#include "glovar.h"

/* Prototipos de funciones externas, definidas en Procesos auxiliares.
   No todas estas funciones son empleadas en "criter.c". */ 
#include "proaux.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
   Sintactica. No todas estas funciones son empleadas en "ob.c". */
#include "unific.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
   Semantica. No todas estas funciones son empleadas en "ob.c". */
#include "narrow.h"
extern struct lprog *bkg_regla(struct arbol *p1, struct arbol *p2,struct prog **millor,struct lprog **mfin);
extern void opti(struct prog *pg);
extern void progagp98(struct prog *pg);
extern void no_rep_ecuacions(struct prog **progam);
extern void agp98(struct arbol *lp);
extern void cob_prog(struct prog *mprog, struct lista *ejp,struct lista *ejn);
extern struct stat *genstat(struct lista *obj);
extern struct funcs *gensimesc(struct lista *ini, struct funcs **sbfin);
extern struct lista *crg(struct arbol *ecu,struct lista *ejn,
			 struct lista *ejp, struct lista **lfin, 
			 struct lista *ini,int tipo);
extern void cob_ecu(struct arbol *ecua);
extern struct prog *sel_mill_prog(struct lprog *listp);


PUBLIC void verres1(struct stat *exitos)
{
        int i; /* para estetica */
	struct stat *s; /* recorre la lista de estados de exito */
	if (exitos)
	{
	   fprintf(out, "\nRESULTADOS: INSTANCIACION DEL OBJETIVO.");
	   for (s=exitos, i=0; s; s=s->sig, i++) 
	     {
	       /* visualiza la substitucion a aplicar */
	       fprintf(out, "\n\nSUSTITUCION theta(%i) = ", i);
	       verunif(s->alfa); fprintf(out,"\n");
	     }
	}
	else fprintf(out,"\nEL OBJETIVO ES IRRESOLUBLE.");
}

PRIVATE void pon_vbles_dcha(struct arbol **ecua)
{
  struct arbol *aux;
  char vbl[10];
  
  for(aux=(*ecua)->hijo;aux;aux=aux->herm)
    {
      fresh(vbl);
      borraecu(aux->hijo);
      aux->hijo=NULL;
      strcpy(aux->oc,vbl);
    }     
}

PRIVATE struct lista *gen_ecus_bkg(struct stat *E,struct arbol *ecua,
				   struct arbol *lhs)
{
  struct arbol *aux,*aux1,*aux2;
  struct lista *auxl,*lecu=NULL,*lfin=NULL;
  struct stat *ls;
  struct subs *lsub;
  int k=0,i;

  for (ls=E;ls;ls=ls->sig)
    {
      k=0;
      /*para cada una de las variables*/
      aux1=copiecu(ecua);
      aux=aux1->hijo;
      aux2=aux1;
      while(aux)
	{
	  aux1=aux2;
	  k++;
	  /* buscamos su correspondiente substitucion*/
	  for (lsub=ls->alfa;lsub;lsub=lsub->sig)
	    {
	      if (strcmp(lsub->var,aux->oc)==0) break;
	    }
	  if (!lsub)
	    {
	    printf (" \n ERROR EN gen_ecus_bkg");
	    exit(-2);
	    }
	  aux2=modifica(aux1,aux,lsub->term);
	  /* verecu(aux2);*/
	  borraecu(aux1);
	  /*no podemos avanzar con aux ya que ahora nos interesa la 
	    modificacion aux2, asi que pasamos al siguiente arg de aux2*/
	  aux=aux2->hijo;
	  for (i=0;i<k;i++)
	    aux=aux->herm;
	}
      auxl=noulista();
      /* montamos la ecuacion con la lhs de las e+, y la rhs generadas*/
      aux=copiecu(lhs);
      borraecu(aux2->herm);
      aux2->herm=NULL;
      aux->herm=aux2;
      auxl->ecu=aux;
      if (!lecu) lecu=auxl;
      else lfin->sig=auxl;
      lfin=auxl;
    }
  return lecu;
}	

PUBLIC struct lprog *gen_bkg(int p, struct lprog **pfin, struct prog **millorp)
{
  struct arbol *ecua,*ecua1;
  struct lista *auxl,*lecu,*ini=NULL,*lfin=NULL,*fin=NULL,*l1,*uaux;
  struct stat *S, /* puntero al estado de narrowing inicial */
    *E; /* puntero a la lista de estados de exito.
      	   Contienen las repuestas computadas. */
  struct funcs *funes;
  struct prog  *mprg=NULL;
  struct lprog  *lprogs=NULL,*lpfin=NULL,*lprx=NULL;
  struct lista *bkgexam;
  int k=0,i;
  
  printf("\n^^^^^^^^ Introducing background in the examples ^^^^^^^\n");
  bkgexam=ejempini;
  for(i=0;(i<p)&&(bkgexam->sig);i++)
    bkgexam=bkgexam->sig;
  /* verecu(bkgexam->ecu);
     printf (" p vale : %d",p);*/
  ecua1=copiecu(bkgexam->ecu);
  /* Y la lhs de la parte izq de la 1 regla del bkg*/ 
  ecua=copiecu(listaini->ecu);
  pon_vbles_dcha(&ecua);
  borraecu(ecua->herm);
  ecua->herm=ecua1->herm;
  /*  printf("");
      verecu(ecua);*/
  ecua1->herm=NULL;
  /*   borraecu(ecua1);*/
  /*printf("\n solucions ll\n");*/
  auxl=noulista();
  auxl->ecu=ecua;
  gensimesc(auxl,&funes);
  start_st('C');
  S = genstat(auxl);
  E = narrower(S,listaini,funescini,1); /*paramos a la 1 solucion*/
  borrastat(S);
  /*  if (E!=NULL) 
    {
      verres1(E);
      }*/
  stop_st();
  lecu=gen_ecus_bkg(E,ecua,ecua1);
  borraecu(ecua1);
  borrastat(E);
  while(lecu)
    {
      bkg=1;
      l1=crg(lecu->ecu,ejempini,ejemnini,&lfin, ini,1);
      bkg=0;
      if (!ini) ini=l1;
      if (fin) fin->sig=l1;
      fin=lfin;
      lecu=lecu->sig;
    }
  printf ("\n Equations with background: \n");
  verlis("",ini);
 printf ("\n Programs generated: \n");
  for (uaux= ini; uaux; uaux= uaux->sig)
    {
      /*k++;*/
      l1=noulista();
      cob_ecu(uaux->ecu);
      l1->ecu=uaux->ecu;
      l1->sig=listaini;
      mprg=nouprog();
      mprg->prg=l1;
      mprg->bkg=1;
      verlis("",mprg->prg);
      /* calculo de optimalidad y coberura de cada programa*/
      cob_prog(mprg,ejempini,ejemnini);
      progagp98(mprg);
      opti(mprg);
      if (mprg->nejn==0)
	{
	  lprx=noulprog();
	  lprx->pro=mprg;
	  if (!lprogs) lprogs=lprx;
	  else lpfin->sig=lprx;
	  lpfin=lprx;
	  printf("coverage of program %d: %d positives, %d negatives map %d,optimalidad %f\n",k,mprg->nejp,mprg->nejn,mprg->cob->mapa,mprg->opt);
	}
      else
	{
	  printf("coverage of  program %d: %d negatives\n",k,mprg->nejn);
	  mprg->prg=NULL;
	  free(mprg);
	}
      *pfin=lpfin;
      k++;
      /*      getchar();*/
    }
  *millorp=sel_mill_prog(lprogs);
  return lprogs;
}

