/*****************************************************************
***************** NARROWING INVERSO*************************
******************************************************************
FICHERO criter.c: Este modulo contiene los procedimientos que
permiten calcular algunos criterios para la eleccion de regas.
Sus unicos puntosde entrada son las funciones:


************************************************************************/

#define pep3 ""
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <math.h>

#include "const.h"
#include "estruc.h"
#include "glovar.h"

extern void cob_ecu(struct arbol *ecua);
extern struct stat *genstat(struct lista *obj);
extern struct funcs *gensimesc(struct lista *ini, struct funcs **sbfin);
extern void opti(struct prog *pg);
extern void progagp98(struct prog *pg);
extern void no_rep_ecuacions(struct prog **progam);
extern void agp98(struct arbol *lp);
extern struct lista *crg(struct arbol *ecu,struct lista *ejn,
			 struct lista *ejp, struct lista **lfin, struct lista *ini,int tipo);
extern void cob_prog(struct prog *mprog, struct lista *ejp,struct lista *ejn);
extern int criterio_parada(struct prog *p2);

/* Prototipos de funciones externas, definidas en Procesos auxiliares.
   No todas estas funciones son empleadas en "criter.c". */ 
#include "proaux.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
   Sintactica. No todas estas funciones son empleadas en "ob.c". */
#include "unific.h"

/* Prototipos de funciones externas, definidas en Fichero de Unificacion
   Semantica. No todas estas funciones son empleadas en "ob.c". */
#include "narrow.h"


/*HACER; unificar con el otro union_progs, de manera que si se pasan los progs como NULL
  sea una union normal, (bueno estes devuelve una lista de ecus no una lista de prg);*/



/* une dos programa ignorando una regla por cada lista*/

PRIVATE struct lista *union_progs2(struct prog *prog1,struct arbol *arb1,struct prog *prog2,struct arbol *arb2)
{
  struct lista *aux,*uaux=NULL,*ini=NULL,*ant=NULL,*ant1=NULL,*ini2=NULL;

  int fbkg =0;  

  for (aux=prog1->prg;aux;aux=aux->sig)
    {
      if (aux->ecu!=arb1)
		{
		  uaux=noulista();
		  uaux->ecu=aux->ecu;
		  if (!ini) ini=uaux;
		  if (ant) ant->sig=uaux;
		  ant=uaux;
		}
      if (aux->sig==listaini)  	 
	{
	  fbkg=1;
	  break;
	}

    }

  for (aux=prog2->prg;aux;aux=aux->sig)
    {
      if (aux->ecu!=arb2)
	{
	  uaux=noulista();
	  uaux->ecu=aux->ecu;
	  if (!ini2) ini2=uaux;
	  if (ant1) ant1->sig=uaux;
	  ant1=uaux;
	}
      if (aux->sig==listaini)  
	{
	  fbkg=1;
	  break;
	}
}
  
  if (ini!=NULL) ant->sig=ini2;
  else ini=ini2;  
  if (fbkg && (uaux)&& (ini)) uaux->sig=listaini;
  else if (!ini) ini=listaini;
  return ini;
}

/* encuentra variables extra en la parte derecha*/

PRIVATE struct ocus_rep *find_vbles_extra(struct arbol *arb)
{
  struct lista *u,*ufin;
  struct ocus   *locus,*oaux;
  struct ocus_rep *rocus,*auxor,*auxor2=NULL,*auxrini=NULL,*tmp;
  
  u= ocubas_solo_var(&arb, &ufin); 
  if (u) { /* hay ocurrencias vbles*/
    locus=list_ocu(u,arb);
    rocus=NULL;
    /* detectamos la vbles extra a la derecha para ello nos aseguramos que todas las variables tengan presencia en la parte izquierda, o sea tengan alguna posicion que empiece por 1 */
    
    repet_ocu(locus,&rocus,arb); 
    oaux=NULL;
    auxrini=rocus;
    auxor=rocus;
    while (auxor)
      {
	for (oaux=auxor->posis;(oaux)&&(oaux->posicion->valor!=1);oaux=oaux->sig);
	if  (oaux!=NULL) 
	  {/* no variable extra, nos interesa*/
	    if (auxor==auxrini) auxrini=auxor->sig;
            else auxor2->sig=auxor->sig;
	    tmp=auxor;
	    auxor=auxor->sig;
	    borraecu(tmp->ocu);borraocus(tmp->posis);
	    free(tmp);
	  }
	else
	  {
	    auxor2=auxor;
	    auxor=auxor->sig;
	  }
      }
    borraocus(locus);
  }
  return auxrini;
  
}   

/* cambia las variables extra de la parte derecha por variables de la parte izquierda*/
PRIVATE struct lista *extra_vbles (struct arbol *ecua, struct ocus_rep *vblx)
{
  struct lista *auxl,*auxlp=0,*u,*ufin,*ini=NULL;
  struct ocus   *locus;
  struct ocus_rep *rocus,*auxor,*auxor2,*auxorb,*auxor2b;
  struct arbol *aux,*euro=NULL;

  
  aux=ecua->herm;
  ecua->herm=NULL;
  u=ocubas_solo_var(&ecua, &ufin); 
  if (u) 
    { /* hay ocurrencias vbles*/
      locus=list_ocu(u,ecua);
      rocus=NULL;
      repet_ocu(locus,&rocus,ecua); 
    }
  else 
    {
      /* no hay ocurrenias variables*/
      return NULL;
    }
  ecua->herm=aux;
  auxor=vblx;
  /* hay mas de una ocurrencia en la rhs*/
  if (auxor->sig)
    {
      while (auxor)
	{
	  auxor2=rocus;
	  while(auxor2)
	    {
	      auxorb=auxor->sig;
	      while(auxorb)
		{
		  if (auxor != auxorb)
		    {
		      auxor2b=rocus;
		      while (auxor2b)
			{
			  if (auxor2!=auxor2b)
			    {
			      auxl=noulista();
			      if (!ini) ini=auxl;
			      else auxlp->sig=auxl;
			      auxlp=auxl;
			      /* if (euro==NULL) euro=ecua;
				 else euro=copiecu(ecua);*/
			      euro=copiecu(ecua);
			      cambiar(euro,auxor->ocu->oc,auxor2->ocu->oc);
			      cambiar(euro,auxorb->ocu->oc,auxor2b->ocu->oc);
			      auxl->ecu=euro;
			    }
			  
			  auxor2b=auxor2b->sig;
			}
		    }
		  auxorb=auxorb->sig;
		}
	      auxor2=auxor2->sig;
	    }
	  auxor=auxor->sig;
      }
    }
  else /*hay solo una ocurrencia*/
    {
      auxor2b=rocus;
      while (auxor2b)
	{
	  auxl=noulista();
	  if (!ini) ini=auxl;
	  else auxlp->sig=auxl;
	  auxlp=auxl;
	  /*if (euro==NULL) euro=copiecu(ecua);
	    else euro=copiecu(ecua);*/
	  euro=copiecu(ecua);
	  cambiar(euro,auxor->ocu->oc,auxor2b->ocu->oc);
	  auxl->ecu=euro;
	  auxor2b=auxor2b->sig;

       }
    }
  borraocus(locus);
  borraecu(ecua);
  borraocus_rep(rocus); 
  return ini;
}



/* analiza la regla a la cual se ha dado la vuelta si es el mismo constructos 
y es mas grande la parte izquierda que la derecha le pegamos la vuelta*/
PRIVATE int analiza_ecu(struct arbol **ecua)
{
  struct arbol *der;
  int change=0;
  
  der=(*ecua)->herm;
  if(strcmp(der->oc,(*ecua)->oc)!=0) 
    {
      agp98(*ecua);
      return 0; /* son distintos simbolos en la cabeza de los trminos*/
    }
  (*ecua)->herm=NULL;
  agp98(*ecua);
  agp98(der);
  if ((der->tam)>((*ecua)->tam)) 
    {/* hay que pegarle la vuelta*/
      change=1;
      der->herm=(*ecua);
      (*ecua)=der;
      (*ecua)->tam=der->herm->tam+der->tam-1; /*hemos sumado dos veces 1*/
    }
  else 
    {
      (*ecua)->herm=der;
      (*ecua)->tam=(*ecua)->tam+der->tam-1; /*hemos sumado dos veces 1*/
    }
  return change;
}
      
/* selecciona el mejor programa, o sea el de mayor cobertura y mayor optimalidad*/
PUBLIC struct prog *sel_mill_prog(struct lprog *listp)
{
  struct prog  *best=NULL;
  struct lprog  *lprogs=NULL;
  double optim=0;
  int cob=0;
  
  if (!listp) return NULL;
  cob=listp->pro->nejp;
  optim=listp->pro->opt;
  best=listp->pro;
  for (lprogs=listp;lprogs;lprogs=lprogs->sig)
    {
      if (lprogs->pro->nejp > cob) 
	{
	  cob=lprogs->pro->nejp;
	  optim=lprogs->pro->opt;
	  best=lprogs->pro;
	}
      else if ((lprogs->pro->nejp == cob)&& (lprogs->pro->opt < optim))
	{
	  cob=lprogs->pro->nejp;
	  optim=lprogs->pro->opt;
	  best=lprogs->pro;
	}
      
    }
  return best;
}

/* selecciona la regla de un programa con mayor cobertura*/
PRIVATE struct arbol *sel_millor_ecu(struct prog *programa)
{
  struct arbol *best=NULL;
  struct lista *laux;
  float mtam=0;
  int cob=0;
  
  if (!programa) return NULL;
  cob=programa->prg->ecu->nejp;
  mtam=programa->prg->ecu->tam;
  best=programa->prg->ecu;
  for (laux=programa->prg;laux;laux=laux->sig)
    {
      if (laux->ecu->nejp> cob) 
	{
	  mtam=laux->ecu->tam;
	  cob=laux->ecu->nejp;
	  best=laux->ecu;
	}
      else 
	if ((laux->ecu->nejp== cob)&& (laux->ecu->tam<mtam))
	  {
	    mtam=laux->ecu->tam;
	    cob=laux->ecu->nejp;
	    best=laux->ecu;

	  }
    }
  return best;
}

/* realiza el narrowing inverso*/

PUBLIC struct lprog *inv_narr(struct prog *p1, struct prog *p2,struct prog **millor,struct lprog **mfin,int bkg)
{
  struct arbol *arb1,*arb2,*aux,*u1,*u2,*stdet,*euro,*fija,*r1,*r2;
  struct lista *locus,*fin=NULL,*uaux,*l1,*l2,*lfin=NULL,*ini=NULL,*ufin=NULL,
    *loaux,*resto=0,*lecu=NULL,*lr1=NULL,*lr2=NULL;
  struct subs  *mgu=NULL;
  struct prog  *mprg=NULL;
  struct lprog  *lprogs=NULL,*lprx=NULL,*lpfin=NULL;
  struct ocus_rep *repoc;
  int k,intento=0,change=0,fin_int,trobat=0;
  
  printf("\n %%%%%%%%%%%%%% Inverse Narrowing %%%%%%%%%%%%%%%%%%\n");
  /* seleccionamos mejor ecuacion del programa*/
  for(lr1=p1->prg;(lr1);lr1=lr1->sig)
    {
    if ((bkg==0)&&(lr1==listaini)) break;
    for(lr2=p2->prg;(lr2);lr2=lr2->sig)
  {
    if ((bkg==0)&&(lr2==listaini)) break;
    /* una variable nos indica si realizar NI con todas las reglas o no */
    if (bkg==1)
      {
	r1=p1->prg->ecu;
	r2=p2->prg->ecu;
	fin_int=1;
      }
    else
      {
	fin_int=2;
	if (mul_inv_nar==0)
	  {
	    r1=sel_millor_ecu(p1);
	    r2=sel_millor_ecu(p2);
	  }
	else
	  { 
	    r1=lr1->ecu;
	    r2=lr2->ecu;	
	  }
	resto=union_progs2(p1,r1,p2,r2);
      }

  intento=0;
  while((intento<fin_int))
    {
      repoc=NULL;lecu=NULL;ini=NULL;
      /* cambiamos regla recep y emis  si en el anterior intento ha fallado*/
      if (intento==1) 
	{
	  aux=r1;
	  r1=r2;
	  r2=aux;
	}
      printf("\n Inverse Narrowing between:\n");
      verecu(r1); /* A->B*/
      verecu(r2); /*C->D*/
      /*getchar();*/
      arb1=copiecu(r1);
      fija=r1;
      arb2=copiecu(r2);
      /*      t1=copiecu(arb1);*/
      /* le pegamos la vuelta a la ecuacion*/
      aux=arb1->herm;
      arb1->herm->herm=arb1;
      arb1->herm=NULL;
      arb1=aux;
      /*B->A*/
      /* calculo de ocurrencias, variables y no variables de D*/
      locus=ocubas_var(&arb2->herm,&ufin);
      /* la ocurrencia mas externa no la tomamos (la primera)*/
      loaux=locus;
      /*	locus=locus->sig;
		loaux->sig=NULL;loaux->ecu=NULL;free(loaux);*/
      /*rocu(pep3,locus);*/
      /*por cada ocurrencia de D*/
      for (uaux= locus; uaux; uaux= uaux->sig)
	{ 
          repoc=NULL;lecu=NULL;
	  change=0;
	  stdet= estandar(arb1); /* estandariza regla B'->A'*/ 
	  u1=copiterm(uaux->ecu); /* ocurrencia de D*/
	  u2=copiterm(stdet);    /*B'*/
	  /*	  printf("\n ocurrencia1");
		  verecu(u1);
		  printf("\n ocurrencia2");
		  verecu(u2);*/
	  mgu=NULL;
	  /*calculo del unificador*/
	  if (unificador(u2,u1,&mgu)){   /* B' unifica con ocu de D*/
	    /*printf("\n sustitucions:");
	      verunif(mgu);*/
	    borraecu(u1);
	    borraecu(u2);
	    /*apliacion de la unificacion*/
	    /* cambia las ocurrencia unificada en C->D*/
	    euro=modifica(arb2,uaux->ecu,stdet->herm); 
	    /* Aplica la unificacion en C'->D'*/
	    aplicar(&euro,mgu);
	    printf ("\n Resulting equation:\n");
	    verecu(euro);
	    /* analiza la ecuacion generada para que no tenga problemas
	       de terminacion*/
	    change=analiza_ecu(&euro);
       	    printf (" \n Analyzed equation:\n");
	    verecu(euro);
	    repoc=find_vbles_extra(euro);
	    if (repoc) printf ("\n There are extra variables on the lhs\n");
	    if (change && repoc) 
	      {
		/*		auxd=euro->herm;*/
		euro->herm->herm=euro;
		euro=euro->herm;
		euro->herm->herm=NULL;
		verecu(euro);
		change=0;
		printf("\n Reinversed the equation\n");
		repoc=NULL; /* faltaria borrar estructura..*/
		repoc=find_vbles_extra(euro);
		if (repoc) printf ("\n There are still extra variables on the lhs");
	      }
	    if (repoc) lecu=extra_vbles(euro,repoc);
	    /* getchar();*/
	    if (lecu) /* se han generado ecuaciones por haber vbles extra rhs*/
	      {
		printf("\n New equation generated by the substituions of extra varaiables:\n");
		verlis(pep3,lecu);
		l2=lecu;
	      }
	    else
	      if (!repoc) /*no hay vbls extra*/
		{
		  l2=noulista();
		  l2->ecu=euro;
		}
	      else l2=NULL; /*hay vbles extra y no se han podido tratar*/
	    while (l2)
	      {
		/*		printf ("\n CRG Equations\n");*/
		l1=crg(l2->ecu,ejempini,ejemnini,&lfin, ini,1);
		if (!ini) ini=l1;
		if (fin) fin->sig=l1;
		fin=lfin;
		l2=l2->sig;
		/*getchar();*/
	      } 
	    /*verlis(pep3,l1);
	      l2=noulista();
	      l2->ecu=euro;
	      l1->sig=l2;*/
	  }
	}
      printf ("\n CRG Equations generated:\n");
      verlis(pep3,ini);
      /*			 gets(&pep3[0]);*/
      borraecu(arb1);
      k=0;
      printf ("\n Programs generated:\n");
  /* se monta un programa con cada ecuacion junto con la mejor de las dos*/
      for (uaux= ini; uaux; uaux= uaux->sig)
	{
	  l2=noulista();
	  l1=noulista();
	  cob_ecu(uaux->ecu);
	  if (bkg==0)
	    {
	      l1->ecu=uaux->ecu;
	      if (change) fija=r2;
	      l2->ecu=fija;
	      l1->sig=l2;
	      l2->sig=resto;
	    }
	  else
	    {
	      l1->ecu=uaux->ecu;
	      l1->sig=listaini;
	    }
	  mprg=nouprog();
	  mprg->prg=l1;
	  verlis(pep3,mprg->prg);
	  no_rep_ecuacions(&mprg);
	  /* printf ("\n eliminadas repeticiones\n");
	     verlis(pep3,mprg->prg);*/
	  /* calculo de optimalidad y coberura de cada programa*/
	  cob_prog(mprg,ejempini,ejemnini);
	  progagp98(mprg);
	  opti(mprg);
	  if (mprg->nejn==0)
	    {
	      lprx=noulprog();
	      lprx->pro=mprg;
	      if (!lprogs) lprogs=lprx;
	      else lpfin->sig=lprx;
	      lpfin=lprx;
	      printf("coverage of program %d: %d positives, %d negatives map %d,optimality %f \n",k,mprg->nejp,mprg->nejn,mprg->cob->mapa,mprg->opt);
	      /* miramos si nos vale este programa para no continuar */
	      if ((mprg->nejp==numejp)&&(stop_now))
		{
		  trobat=1;
		  break;
		}
	    }
	  else  printf("\ncoverage of program %d: %d negatives \n",k,mprg->nejn);
	  k++;
	  /*	  getchar();*/
	}
      *mfin=lpfin;
      if ((trobat)&&(stop_now))  /* prg encontrado, salimos*/
	{
	  printf("jopla");
	  *millor=mprg;
	  return lprogs;
	}
      else *millor=sel_mill_prog(lprogs);
      intento++;
    }
  if ((mul_inv_nar==0)||(bkg==1)) break;
  }
  }
  return lprogs;

}



/* realiza el narrowing inverso*/

PUBLIC struct lprog *bkg_regla(struct arbol *p1, struct arbol *p2,struct prog **millor,struct lprog **mfin)
{
  struct arbol *arb1,*arb2,*aux,*u1,*u2,*stdet,*euro,*fija,*r1,*r2;
  struct lista *locus,*fin=NULL,*uaux=NULL,*l1=NULL,*l2=NULL,*lfin=NULL,*ini=NULL,*ufin=NULL,
    *loaux=NULL,*lecu=NULL;
  struct subs  *mgu=NULL;
  struct prog  *mprg=NULL;
  struct lprog  *lprogs=NULL,*lprx=NULL,*lpfin=NULL;
  struct ocus_rep *repoc;
  int k,intento=0,change;
  /* seleccionamos mejor ecuacion del programa*/
  /*  r1=sel_millor_ecu(p1);
      r2=sel_millor_ecu(p2);*/
  r1=p1;
  r2=p2;
  /*  resto=union_progs2(p1,r1,p2,r2);*/

  while((intento<1)&&(!lprogs))
    {
      repoc=NULL;lecu=NULL;ini=NULL;
      /* cambiamos regla recep y emis  si en el anterior inento ha fallado*/
      if (intento==1) 
	{
	  aux=r1;
	  r1=r2;
	  r2=aux;
	}
      printf("\n Inverse Narrowing between equations :\n");
      verecu(r1); /* A->B*/
      verecu(r2); /*C->D*/
      /*getchar();*/
      arb1=copiecu(r1);
      fija=r1;
      arb2=copiecu(r2);
      /*      t1=copiecu(arb1);*/
      /* le pegamos la vuelta a la ecuacion*/
      aux=arb1->herm;
      arb1->herm->herm=arb1;
      arb1->herm=NULL;
      arb1=aux;
      /*B->A*/
      /* calculo de ocurrencias, variables y no variables de D*/
      locus=ocubas_var(&arb2->herm,&ufin);
      /* la ocurrencia mas externa no la tomamos (la primera)*/
      loaux=locus;
      /*	locus=locus->sig;
		loaux->sig=NULL;loaux->ecu=NULL;free(loaux);*/
      /*rocu(pep3,locus);*/
      /*por cada ocurrencia de D*/
      for (uaux= locus; uaux; uaux= uaux->sig)
	{ 
          repoc=NULL;lecu=NULL;
	  change=0;
	  stdet= estandar(arb1); /* estandariza regla B'->A'*/ 
	  u1=copiterm(uaux->ecu); /* ocurrencia de D*/
	  u2=copiterm(stdet);    /*B'*/
	  /*	  printf("\n ocurrencia1");
		  verecu(u1);
		  printf("\n ocurrencia2");
		  verecu(u2);*/
	  mgu=NULL;
	  /*calculo del unificador*/
	  if (unificador(u2,u1,&mgu)){   /* B' unifica con ocu de D*/
	    /*printf("\n sustitucions:");
	      verunif(mgu);*/
	    borraecu(u1);
	    borraecu(u2);
	    /*apliacion de la unificacion*/
	    /* cambia las ocurrencia unificada en C->D*/
	    euro=modifica(arb2,uaux->ecu,stdet->herm); 
	    /* Aplica la unificacion en C'->D'*/
	    aplicar(&euro,mgu);
	    printf ("\n ecuacion narrowing inverso\n");
	    verecu(euro);
	    /* analiza la ecuacion generada para que no tenga problemas
	       de terminacion*/
	    change=analiza_ecu(&euro);
	    printf (" \n ecuacion narrowing inverso analizada\n");
	    verecu(euro);
	    repoc=find_vbles_extra(euro);
	    if (repoc) printf ("\n HAY VBLS EXTRA");
	    if (repoc) lecu=extra_vbles(euro,repoc);
	    /*	    getchar();*/
	    if (lecu) /* se han generado ecuaciones por haber vbles extra rhs*/
	      {
		printf("\n ecuciones generadas eliminacion de Vble extra rhs\n");
		verlis(pep3,lecu);
		l2=lecu;
	      }
	    else
	      if (!repoc) /*no hay vbls extra*/
		{
		  l2=noulista();
		  l2->ecu=euro;
		}
	      else l2=NULL; /*hay vbles extra y no se han podido tratar*/
	    while (l2)
	      {
		printf ("\n ecuaciones CRG\n");
		l1=crg(l2->ecu,ejempini,ejemnini,&lfin, ini,1);
		if (!ini) ini=l1;
		if (fin) fin->sig=l1;
		fin=lfin;
		l2=l2->sig;
		/*getchar();*/
	      } 
	    /*verlis(pep3,l1);
	      l2=noulista();
	      l2->ecu=euro;
	      l1->sig=l2;*/
	  }
	}
      printf ("\n ecuaciones finales\n");
      verlis(pep3,ini);
      /*			 gets(&pep3[0]);*/
      borraecu(arb1);
      k=0;
  /* se monta un programa con cada ecuacion junto con la mejor de las dos*/
      for (uaux= ini; uaux; uaux= uaux->sig)
	{
	  l2=noulista();
	  l1=noulista();
	  cob_ecu(uaux->ecu);
	  l1->ecu=uaux->ecu;
	  /*	  if (change) fija=r2;
		  l2->ecu=fija;*/
	  /*	  l1->sig=l2;*/
	  l1->sig=listaini;
	  mprg=nouprog();
	  mprg->prg=l1;
	  verlis(pep3,mprg->prg);
	  no_rep_ecuacions(&mprg);
	  /* printf ("\n eliminadas repeticiones\n");
	     verlis(pep3,mprg->prg);*/
	  /* calculo de optimalidad y coberura de cada programa*/
	  cob_prog(mprg,ejempini,ejemnini);
	  progagp98(mprg);
	  opti(mprg);
	  if (mprg->nejn==0)
	    {
	      lprx=noulprog();
	      lprx->pro=mprg;
	      if (!lprogs) lprogs=lprx;
	      else lpfin->sig=lprx;
	      lpfin=lprx;
	      printf("\ncobertura programa %d:%d positivos, %d negativos mapa %d,optimalidad %f",k,mprg->nejp,mprg->nejn,mprg->cob->mapa,mprg->opt);
	     
	    }
	  else  printf("\ncobertura programa%d: %d negativos",k,mprg->nejn);
	  k++;
	  /*	  getchar();*/
	}
        *mfin=lpfin;
      *millor=sel_mill_prog(lprogs);
      intento++;
    }
  return lprogs;
}
